#Include "Defines.bi"
#Include "BMPsEinfachLaden.bi"
#Include "TimeControlUDT.bi"

Declare Sub Save()
Declare Sub G()
Declare Sub LoadFiles()
Declare Sub Steu()
Declare Sub LoadMap()

Screenres ScreenMaxX, ScreenMaxY, 32,, &h08

Dim Shared as Byte Area(1 to 18, 1 to 15)
Dim Shared as Any PTR Environment(1 to EnvironmentMax)
Dim Shared as Byte Auswahl = 1
Dim Shared as Byte AuswahlLock
Dim as TimeControlUDT TimeControl

LoadFiles()
LoadMap()
G()

While(Not Multikey(&h01))
    TimeControl.StartTime = Timer
    
    Steu()
    
    TimeControl.EndTime = Timer
    TimeControl.ControlTime()
Wend

Save()
End 0

'###############################################################################
Sub Save()
    Dim as Integer File = Freefile
    Dim as Integer a, b
    
    If Open("map\Map" for Random Access Write as #File) <> 0 then
        ?"[Error]Something went wrong while loading map file."
        Sleep
        End -1
    Endif
        
    For a = 1 to 18
        For b = 1 to 15
            Put #File,, Area(a, b)
        Next b
    Next a
    Close #File
End Sub

'###############################################################################
Sub G()
    Dim as Integer a, b
    
    For a = 1 to 18
        For b = 1 to 15
            If Area(a, b) > 0 then
                Put ((a - 1) * 32, (b - 1) * 32), Environment(Area(a, b)), ALPHA, 255
            Endif
        Next b
    Next a
End Sub

'###############################################################################
Sub LoadFiles()
    Dim a as Integer
    
    Environment(1) = LoadImgFile("imgs\environment\brick1.bmp")
    Environment(2) = LoadImgFile("imgs\environment\brick2.bmp")
    Environment(3) = LoadImgFile("imgs\environment\brick3.bmp")
    Environment(4) = LoadImgFile("imgs\environment\massive.bmp")
    Environment(5) = LoadImgFile("imgs\environment\water1.bmp")
    Environment(6) = LoadImgFile("imgs\environment\water2.bmp")
    Environment(7) = LoadImgFile("imgs\environment\water3.bmp")
    Environment(8) = LoadImgFile("imgs\environment\stealth.bmp")
    
    For a = 1 to EnvironmentMax
        If Environment(a) = 0 then
            ?"[Error]Something went wrong while loading .bmp files."
            Sleep
            End -1
        Endif
    Next a
End Sub

'###############################################################################
Sub Steu()
    Dim as Integer X, Y, Button
    Dim as Integer a, b
    GetMouse(X, Y,, Button)
    
    If Not Multikey(&h1E) and Not Multikey(&h1F) then AuswahlLock = 0
    If AuswahlLock = 0 then
        If Multikey(&h1E) then Auswahl -= 1 : AuswahlLock = 1
        If Multikey(&h1F) then Auswahl += 1 : AuswahlLock = 1
        If Auswahl < 0 then Auswahl = 0
        If Auswahl > EnvironmentMax then Auswahl = EnvironmentMax
    Endif
    For a = 1 to 18
        For b = 1 to 15
            If X > (a - 1) * 32 and X < a * 32 and Y > (b - 1) * 32 and Y < b * 32 then
                CLS
                G()
                If Auswahl > 0 then Put ((a - 1) * 32, (b - 1) * 32), Environment(Auswahl), ALPHA, 255
                If Button = 1 then
                    Area(a, b) = Auswahl
                Endif
            Endif
        Next b
    Next a
End Sub

'###############################################################################
Sub LoadMap()
    Dim as Integer File = Freefile
    Dim as Integer a, b
    
    If Open("map\Map" for Random Access Read as #File) <> 0 then
        ?"[Error]Something went wrong while loading map file."
        Sleep
        End -1
    Endif
        
    For a = 1 to 18
        For b = 1 to 15
            Get #File,, Area(a, b)
        Next b
    Next a
    Close #File
End Sub

