Type FieldManagerUDT
    Dim as Byte Area(1 to 18, 1 to 15)
    Dim as Any PTR Environment(1 to EnvironmentMax)
    
    Declare Constructor()
    Declare Sub LoadFiles()
    Declare Sub LoadMap()
    Declare Sub G()
End Type

'###############################################################################
Constructor FieldManagerUDT()
    LoadFiles()
    LoadMap()
End Constructor

'###############################################################################
Sub FieldManagerUDT.LoadFiles()
    Dim a as Integer
    
    Environment(1) = LoadImgFile("imgs\environment\brick1.bmp")
    Environment(2) = LoadImgFile("imgs\environment\brick2.bmp")
    Environment(3) = LoadImgFile("imgs\environment\brick3.bmp")
    Environment(4) = LoadImgFile("imgs\environment\massive.bmp")
    Environment(5) = LoadImgFile("imgs\environment\water1.bmp")
    Environment(6) = LoadImgFile("imgs\environment\water2.bmp")
    Environment(7) = LoadImgFile("imgs\environment\water3.bmp")
    Environment(8) = LoadImgFile("imgs\environment\stealth.bmp")
    
    For a = 1 to EnvironmentMax
        If Environment(a) = 0 then
            ?"[Error]Something went wrong while loading .bmp files."
            Sleep
            End -1
        Endif
    Next a
End Sub

'###############################################################################
Sub FieldManagerUDT.LoadMap()
    Dim as Integer File = Freefile
    Dim as Integer a, b
    
    If Open("map\Map" for Random Access Read as #File) <> 0 then
        ?"[Error]Something went wrong while loading map file."
        Sleep
        End -1
    Endif
        
    For a = 1 to 18
        For b = 1 to 15
            Get #File,, Area(a, b)
        Next b
    Next a
    Close #File
End Sub

'###############################################################################
Sub FieldManagerUDT.G()
    Dim as Integer a, b
    
    For a = 1 to 18
        For b = 1 to 15
            If Area(a, b) > 0 then
                Put ((a - 1) * 32, (b - 1) * 32), Environment(Area(a, b)), ALPHA, 255
            Endif
        Next b
    Next a
End Sub


